"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var misc_utils_of_mine_generic_1 = require("misc-utils-of-mine-generic");
var canvasRender_1 = require("../browser/canvasRender");
var fileType = require("file-type");
/**
  Example of declaring a format codec that uses DOM canvas instance which must be provided by the user.
  
```ts
import  jimp from 'jimp'
class JimpProxy implements FormatProxyClass {
  async create() {
   return new JimpFormatCodec(Jimp)
  }
}
```
 */
var CanvasCodec = /** @class */ (function () {
    function CanvasCodec() {
    }
    CanvasCodec.prototype.decode = function (buffer, format) {
        return __awaiter(this, void 0, void 0, function () {
            var tt, mime, _a, canvas, height, width, imgData;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        mime = format ? misc_utils_of_mine_generic_1.getMimeTypeForExtension(format) : (tt = fileType(buffer)) && tt.mime || undefined;
                        if (!mime) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, canvasRender_1.renderArrayBufferInCanvas(buffer, mime)];
                    case 1:
                        _a = _b.sent(), canvas = _a.canvas, height = _a.height, width = _a.width;
                        imgData = canvas.getContext('2d').getImageData(0, 0, width, height);
                        return [2 /*return*/, imgData];
                }
            });
        });
    };
    CanvasCodec.prototype.encode = function (data, format, quality) {
        return __awaiter(this, void 0, void 0, function () {
            var mat, canvas_1;
            return __generator(this, function (_a) {
                try {
                    mat = cv.matFromImageData(data);
                    canvas_1 = canvasRender_1.renderInCanvas(mat, { forceSameSize: true, rgba: true });
                    mat.delete();
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            canvas_1.toBlob(function (b) {
                                if (!b) {
                                    return resolve(undefined);
                                }
                                var r = new FileReader();
                                r.onloadend = function (a) {
                                    resolve(r.result || undefined);
                                };
                                r.onerror = r.onabort = function () {
                                    r.error ? reject(r.error) : resolve(undefined);
                                };
                                r.readAsArrayBuffer(b);
                            }, misc_utils_of_mine_generic_1.getMimeTypeForExtension(format) || 'image/png', quality);
                        })];
                }
                catch (error) {
                    console.error(error);
                }
                return [2 /*return*/];
            });
        });
    };
    return CanvasCodec;
}());
exports.CanvasCodec = CanvasCodec;
//# sourceMappingURL=canvasCodec.js.map